FP_LESSTHAN	equ	01h
FP_EQUALTO	equ	40h

CONSTANT SECTION

RDBGTen		dq	10.0
RDBGTen16	dq	1.0e16

RDBGF2ATen_1	dt	1.0e1
			dt	1.0e2
			dt	1.0e3
			dt	1.0e4
			dt	1.0e5
			dt	1.0e6
			dt	1.0e7
			dt	1.0e8
			dt	1.0e9
			dt	1.0e10
			dt	1.0e11
			dt	1.0e12
			dt	1.0e13
			dt	1.0e14
			dt	1.0e15

RDBGF2ATen_16	dt	1.0e16
				dt	1.0e32
				dt	1.0e48
				dt	1.0e64
				dt	1.0e80
				dt	1.0e96
				dt	1.0e112
				dt	1.0e128
				dt	1.0e144
				dt	1.0e160
				dt	1.0e176
				dt	1.0e192
				dt	1.0e208
				dt	1.0e224
				dt	1.0e240

RDBGF2ATen_256	dt	1.0e256
				dt	1.0e512
				dt	1.0e768
				dt	1.0e1024
				dt	1.0e1280
				dt	1.0e1536
				dt	1.0e1792
				dt	1.0e2048
				dt	1.0e2304
				dt	1.0e2560
				dt	1.0e2816
				dt	1.0e3072
				dt	1.0e3328
				dt	1.0e3584
				dt	1.0e4096
				dt	1.0e4352
				dt	1.0e4608
				dt	1.0e4864

CODE SECTION

_RDBGStrToDouble@8	FRAME szIn, fpout
	LOCAL	sign: B
	LOCAL	expsign: B
	LOCAL	decimal: D
	LOCAL	stat: W
	LOCAL	temp: W

	// Clear MMX mode if its on
	emms
	// By Tim Roberts

    xor eax, eax
    mov [sign], al
    mov [expsign], al
    mov D[decimal], -1

    fstcw W[stat]
    mov W[temp], 027fh
    fldcw W[temp]

    mov esi, [szIn]
    mov al, [esi]

    cmp al,"+"
    jne >
		inc	esi
		mov	al, [esi]
		jmp >.SIGNDONE
	:
	cmp al,"-"
	jne >.SIGNDONE
		inc	esi
		mov	B[sign], 1
		mov	al, [esi]
    .SIGNDONE

    cmp al, 0
    je >>.sdExit

    fclex
    xor ebx, ebx
    fldz
    xor ecx, ecx

.cvtloop
    cmp al, 'E'
    je >.doExponent
    cmp al, 'e'
    je >.doExponent

    cmp al,"."
    jne >
	mov [decimal], ebx
	jmp >>.DECIMALDONE
    :
	sub al, '0'
	jb >.sdFinish
	cmp al, 9
	ja >.sdFinish
	mov [temp], ax
	fmul Q[RDBGTen]
	fiadd W[temp]
	inc ebx
    .DECIMALDONE

    inc esi
    mov al, [esi]
    jnz .cvtloop
    jmp >.sdFinish

.doExponent
    inc esi
    mov al, [esi]
    cmp al, 0
    jz >.sdFinish

    cmp al,"+"
    jne >
	inc esi
	mov al, [esi]
	jmp >>.SIGN2
	cmp al,"-"
	jne >>.SIGN2
	inc esi
	mov B[expsign], 1
	mov al, [esi]
    .SIGN2

    cmp al, 0
    jz >.sdFinish

.expLoop
    sub al, '0'
    jb >.sdFinish
    cmp al, 9
    ja >.sdFinish
    imul ecx, 10
    add ecx, eax

    inc esi
    mov al, [esi]
    jnz .expLoop

.sdFinish

    cmp B[expsign],0
    je >
	neg ecx
    :
    mov eax, [decimal]

    cmp eax,-1
    je >
	sub ebx, eax
	sub ecx, ebx
    :

    mov eax, ecx
    call RDBGPowerOf10

    cmp B[sign],0
    je >
	fchs
    :

    mov edi, [fpout]
    fstp Q[edi]
    fwait

.sdExit
    fldcw W[stat]
    mov eax, esi
    ret

ENDF

_RDBGDoubleToStr@12	FRAME fpinLo,fpinHi,szDbl
	USES esi, edi 
	LOCAL	iExp:D
	LOCAL	stat:W
	LOCAL	mystat:W
	LOCAL	fpin:Q
	LOCAL	szDbgF2ATemp[18]:B

	// Clear MMX mode if its on
	emms

	// By Tim Roberts

	mov eax,[fpinLo]
	mov [fpin],eax
	mov eax,[fpinHi]
	mov [fpin+4],eax

	mov edi,[szDbl]

	cmp D[fpin],0
	jne >
	cmp D[fpin+4],0
	jne >
		mov D[edi],'0.0'
		ret
	:

	cmp D[fpin+4],0
	jge >
		and B[fpin+7],0x7F
		mov B[edi],'-'
		inc edi
	:

	fclex
	fstcw W[stat]
	mov W[mystat],0x27F
	fldcw W[mystat]

	fld Q[fpin]
	fld st0

	fxtract
	fstp st0
	fldlg2
	fmulp st1, st
	fistp D[iExp]

	cmp D[iExp],16
	jge >.NONINTEGER
		fld st0
		frndint
		fcomp st1
		fstsw ax
		test ah,FP_EQUALTO
		jz >.NONINTEGER

		invoke RDBGDoubleToBCD,offset szDbgF2ATemp

		mov eax,17
		mov ecx,[iExp]
		sub eax,ecx
		inc ecx
		lea esi,[szDbgF2ATemp+eax]

		cmp B[esi],"0"
		jne >
			inc esi
			dec ecx
		:

		rep movsb
		mov D[edi],".0"
		fldcw W[stat]
		fwait
		ret

	.NONINTEGER

	mov eax,16
	sub eax,[iExp]
	call RDBGPowerOf10

	fcom Q[RDBGTen16]
	fstsw ax
	test ah,1
	jz >
		fmul Q[RDBGTen]
		dec D[iExp]
	:

	invoke RDBGDoubleToBCD,offset szDbgF2ATemp
	lea esi,[szDbgF2ATemp+1]

	mov ecx, [iExp]
	cmp ecx,-15
	jl >>.DONE
	cmp ecx,16
	jg >>.DONE

		inc ecx
		cmp ecx,0
		jg >
			mov W[edi],'0.'
			add edi,2
			neg ecx
			mov al,'0'
			rep stosb
			mov ecx, 16
			jmp >.ENTRYDONE
		:
			rep movsb
			mov B[edi],'.'
			inc edi
			mov ecx, 16
			sub ecx,[iExp]
		.ENTRYDONE
		rep movsb

		.TRIMZERO
		cmp B[edi-1],"0"
		jne >
			dec edi
			jmp .TRIMZERO
		:

		.TRIMTODEC
			cmp B[edi-1],"."
			jne >
			dec edi
			jmp .TRIMTODEC
		:

		jmp >>.ftsExit

	.DONE

	movsb
	mov B[edi],'.'
	inc edi
	movsd
	movsw

	mov B[edi],'e'
	mov eax, [iExp]
	cmp eax,0
	jnl >
		mov B[edi+1],'-'
		neg eax
		jmp >.EXPSIGN
	:
		mov B[edi+1],'+'
	.EXPSIGN

    mov ecx, 10

	xor edx, edx
	div ecx
	add dl, '0'
	mov [edi+4], dl

	xor edx, edx
	div ecx
	add dl, '0'
	mov [edi+3], dl

	xor edx, edx
	div ecx
	add dl, '0'
	mov [edi+2], dl

	add edi, 5

.ftsExit
	mov B[edi],0
	fldcw W[stat]
	fwait

	ret
ENDF

_RDBGDoubleToBCD@4 FRAME pszTemp
	uses esi, edi
	LOCAL bcd[10]:B

	sub esp,10
    fbstp T[bcd]

    lea esi, [bcd+8]
    mov edi,[pszTemp]
    mov ecx, 9

    :
	mov al, [esi]
	dec esi
	rol ax, 12
	rol ah, 4
	and ax, 0f0fh
	add ax, 3030h
	mov [edi], ax
	add edi, 2
	dec ecx
	jnz <
	ret
ENDF

_RDBGPowerOf10@0:

	mov ecx, eax
	test eax,eax
	jns >
		neg eax
	:

	fld1

	mov dl, al
	and edx, 0fh
	jz >
		lea edx, [edx+edx*4]
		fld T[RDBGF2ATen_1+edx*2-10]
		fmulp st1, st
	:

	mov dl, al
	shr dl, 4
	and edx, 0fh
	jz >
		lea edx, [edx+edx*4]
		fld T[RDBGF2ATen_16+edx*2-10]
		fmulp st1, st
	:

	mov dl, ah
	and edx, 1fh
	jz >
		lea edx, [edx+edx*4]
		fld T[RDBGF2ATen_256+edx*2-10]
		fmulp st1, st
	:

    test ecx,ecx
    jns >
		fdivp st1, st
		ret

    :
		fmulp st1, st
		ret
