;##################################################################
; Debug Break Dialog
;##################################################################

DBGBRK_DLG_PARAMS STRUCT
	Exe		DB 260 DUP
	File	DB 260 DUP
	Line	DD
ends

CODE SECTION

RDBG_BRK_MessageBox FRAME pDBGBRK_DLG_PARAMS
	invoke RDBG_BRK_WinMain,NULL,NULL,[pDBGBRK_DLG_PARAMS],SW_SHOW
	ret
endf

RDBG_BRK_WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:%HANDLE
	LOCAL hMainFont:%HANDLE
	LOCAL hIcon:%HANDLE
	LOCAL lf:LOGFONT
	LOCAL hInstanceLoc:%HANDLE

	invoke GetModuleHandleA,NULL
	mov [hInstanceLoc],rax

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov Q[wc.lpfnWndProc], OFFSET RDBG_BRK_WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstanceLoc]
	pop [wc.hInstance]
	mov Q[wc.hbrBackground],COLOR_BTNFACE+1
	mov Q[wc.lpszMenuName],NULL
	mov Q[wc.lpszClassName],OFFSET RDBG_BRK_Classname

	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],rax
	mov [wc.hIconSm],rax

	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],rax

	invoke RegisterClassExA, addr wc
	invoke CreateWindowExA,NULL,OFFSET RDBG_BRK_Classname,ADDR RDBG_BRK_Caption,\
			WS_CAPTION + WS_VISIBLE,CW_USEDEFAULT,\
			CW_USEDEFAULT,430,300,NULL,NULL,\
			[hInstanceLoc],NULL

	mov [hwnd],rax

	invoke LoadIconA,NULL,IDI_HAND
	mov [hIcon],rax

	invoke GetStockObject,ANSI_VAR_FONT
	mov [hMainFont],rax

	// Create our controls
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,NULL,SS_ICON + WS_CHILD + WS_VISIBLE,12,12,32,32,[hwnd],1001,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_ICON,[hIcon]

	invoke SendDlgItemMessageA,[hwnd],1001,WM_SETFONT,[hMainFont],TRUE
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,offset RDBG_BRK_DbgBreakMsg,SS_LEFT+WS_CHILD + WS_VISIBLE,57,16,300,23,[hwnd],1002,[hInstanceLoc],NULL

	mov D[lf.lfHeight],-16
	mov D[lf.lfWidth],0
	mov D[lf.lfEscapement],0
	mov D[lf.lfOrientation],0
	mov D[lf.lfWeight],400
	mov D[lf.lfItalic],0
	mov D[lf.lfUnderline],0
	mov D[lf.lfStrikeOut],0
	mov D[lf.lfCharSet],0
	mov D[lf.lfOutPrecision],3
	mov D[lf.lfClipPrecision],2
	mov D[lf.lfQuality],1
	mov D[lf.lfPitchAndFamily],34
	mov D[lf.lfFaceName],"Aria"
	mov D[lf.lfFaceName+4],"l Bl"
	mov D[lf.lfFaceName+8],"ack"

	invoke CreateFontIndirectA,offset lf
	invoke SendDlgItemMessageA,[hwnd],1002,WM_SETFONT,rax,TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,offset RDBG_BRK_ProgLabel,SS_LEFT+WS_CHILD + WS_VISIBLE,21,60,50,16,[hwnd],1003,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1003,WM_SETFONT,[hMainFont],TRUE
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,offset RDBG_BRK_FileLabel,SS_LEFT+WS_CHILD + WS_VISIBLE,21,80,50,16,[hwnd],1005,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1005,WM_SETFONT,[hMainFont],TRUE
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,offset RDBG_BRK_LineLabel,SS_LEFT+WS_CHILD + WS_VISIBLE,21,100,50,16,[hwnd],1007,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1007,WM_SETFONT,[hMainFont],TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,NULL,SS_LEFT+WS_CHILD + WS_VISIBLE,71,60,300,16,[hwnd],1004,[hInstanceLoc],NULL
	mov rbx,[CmdLine]
	add rbx,DBGBRK_DLG_PARAMS.Exe
	invoke GetModuleFileNameA,NULL,rbx,260
	invoke PathFindFileNameA,rbx
	invoke SendDlgItemMessageA,[hwnd],1004,WM_SETTEXT,0,rax
	invoke SendDlgItemMessageA,[hwnd],1004,WM_SETFONT,[hMainFont],TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,NULL,SS_LEFT+WS_CHILD + WS_VISIBLE,71,80,300,16,[hwnd],1006,[hInstanceLoc],NULL
	mov rax,[CmdLine]
	add rax,DBGBRK_DLG_PARAMS.File
	invoke SendDlgItemMessageA,[hwnd],1006,WM_SETTEXT,0,rax
	invoke SendDlgItemMessageA,[hwnd],1006,WM_SETFONT,[hMainFont],TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,NULL,SS_LEFT+WS_CHILD + WS_VISIBLE,71,100,300,16,[hwnd],1008,[hInstanceLoc],NULL
	mov rax,[CmdLine]
	add rax,DBGBRK_DLG_PARAMS.Line
	invoke SetDlgItemInt,[hwnd],1008,[rax],FALSE
	invoke SendDlgItemMessageA,[hwnd],1008,WM_SETFONT,[hMainFont],TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Static,offset RDBG_BRK_Instructions,SS_LEFT+WS_CHILD + WS_VISIBLE,21,140,300,64,[hwnd],1009,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1009,WM_SETFONT,[hMainFont],TRUE

	invoke CreateWindowExA,NULL,offset RDBG_BRK_Button,offset RDBG_BRK_Continue,BS_CENTER + WS_CHILD + WS_VISIBLE,104,203,94,32,[hwnd],11,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],11,WM_SETFONT,[hMainFont],TRUE
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Button,offset RDBG_BRK_OK,BS_CENTER + WS_CHILD + WS_VISIBLE,204,203,94,32,[hwnd],1,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],1,WM_SETFONT,[hMainFont],TRUE
	invoke CreateWindowExA,NULL,offset RDBG_BRK_Button,offset RDBG_BRK_Ignore,BS_CENTER + WS_CHILD + WS_VISIBLE,305,203,94,32,[hwnd],5,[hInstanceLoc],NULL
	invoke SendDlgItemMessageA,[hwnd],5,WM_SETFONT,[hMainFont],TRUE

	invoke ShowWindow, [hwnd],[CmdShow]
	invoke UpdateWindow, [hwnd]

	.messloop
		invoke GetMessage, ADDR msg,0,0,0
		or eax,eax
		JZ >.quit
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage, ADDR msg
	JMP .messloop
	.quit

	mov rax,[msg.wParam]
	ret

	RDBG_BRK_Classname: DB A"DbgBreakWindow",0
	RDBG_BRK_Caption:	DB A"Donkey Debug",0
	RDBG_BRK_DbgBreakMsg: DB A"DbgBreak encountered",0
	RDBG_BRK_ProgLabel: DB A"Program:",0
	RDBG_BRK_FileLabel: DB A"File:",0
	RDBG_BRK_LineLabel: DB A"Line:",0

	RDBG_BRK_Instructions: DB A"Press IGNORE to bypass",13,10,A"Press OK to dump debug information",13,10,A"Press CONTINUE to continue to the default SEH",0

	RDBG_BRK_Static: DB A"STATIC",0
	RDBG_BRK_Button: DB A"BUTTON",0

	RDBG_BRK_Continue: DB A"CONTINUE",0
	RDBG_BRK_OK: DB A"OK",0
	RDBG_BRK_Ignore: DB A"IGNORE",0

ENDF

RDBG_BRK_WndProc FRAME hwnd, uMsg, wParam, lParam

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		mov rax,[wParam]
		and rax,0xFF
		// Should be SetWindowLongPtrA

		invoke SetWindowLongA,[hwnd],GWLP_USERDATA,rax
		invoke PostMessageA,[hwnd],WM_CLOSE,0,0
		jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.WM_DESTROY
		invoke DestroyWindow,[hwnd]
		jmp >>.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >>.DEFPROC
		invoke SendDlgItemMessageA,[hwnd],1002,WM_GETFONT,0,0
		invoke DeleteObject,rax
		invoke GetWindowLongA,[hwnd],GWLP_USERDATA
		invoke PostQuitMessage,rax
		jmp >>.DEFPROC

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]		
		ret

	.EXIT

	xor eax,eax
	ret
ENDF
