;##################################################################
; DbgWin
;##################################################################

#include DbgWin.h

DEBUGLIB equ \Programming\RadASM3\GoAsm\dbg\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\dbg\dbgwin.exe"
#include "\Programming\RadASM3\GoAsm\dbg\debug.a"
DBGWIN_DEBUG_ON = 0 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists

IDD_DLG1			equ		1000
BMPTOOLBAR			equ		3000
S=4

DATA SECTION
	hInstance			HANDLE 		?
	hDlg				HANDLE		?
	hEdit				HANDLE		?
	hImlToolbar			HANDLE		?
	hToolbar			HANDLE		?

	szFilterStr			CHAR		"Debug data file (*.ddf)",0,"*.ddf",0,0
	szDefExt			CHAR		"DDF",0
	szOpenCaption		CHAR		"Open debug data file",0
	szSaveCaption		CHAR		"Save debug data file",0
	ofrFilePath			CHAR		MAX_PATH DUP (?)

	ClassName			DB			"DbgWinClass",0
	hFont				HANDLE		?
	Courier_New_9		LOGFONT 	<-12,0,0,0,400,0,0,0,0,3,2,1,49,"Courier New">

	ALIGN 16
	tbrbtns				TBBUTTON	<0,5000,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
						TBBUTTON	<1,5001,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,1,0>
						TBBUTTON	<2,5002,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,2,0>
						TBBUTTON	<3,5003,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,3,0>
	tbbend:
	nToolbarBtns		equ	(tbbend-tbrbtns) /SIZEOF TBBUTTON

	fAlwaysOnTop		DD			FALSE

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],rax
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:%HANDLE
	LOCAL	rect			:RECT
	LOCAL	rect2			:RECT

	; Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		S[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		rax, [hInstance]
	mov		S[wc.hInstance], rax
	mov		S[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		S[wc.lpszMenuName], NULL
	mov		S[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		S[wc.hIcon], rax
	mov		S[wc.hIconSm], rax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		S[wc.hCursor], rax

	invoke	RegisterClassEx, offset wc
	or rax,rax
	jnz >
		; If unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke	CreateDialogParam, [hInstance],IDD_DLG1, NULL, NULL, NULL
	or rax,rax
	jnz >
		; If unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],rax

	invoke GetDlgItem,[hDlg],1001
	mov [hEdit],eax
	invoke GetDlgItem,[hDlg],1002
	mov [hToolbar],eax

	invoke ImageList_LoadImage,[hInstance],BMPTOOLBAR,16,16,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hImlToolbar],eax
	invoke SendMessage,[hToolbar],TB_BUTTONSTRUCTSIZE,SIZEOF TBBUTTON,0
	invoke ImageList_SetBkColor,[hImlToolbar],CLR_NONE
	invoke SendMessage,[hToolbar],TB_SETIMAGELIST,0,[hImlToolbar]
	invoke SendMessage,[hToolbar],TB_SETINDENT,8,0
	invoke SendMessage,[hToolbar],TB_ADDBUTTONS,nToolbarBtns,OFFSET tbrbtns
	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0

	invoke GetClientRect,[hDlg],offset rect
	invoke GetWindowRect,[hToolbar],offset rect2
	mov eax,[rect2.bottom]
	sub eax,[rect2.top]
	add [rect.top],eax
	sub [rect.bottom],eax
	invoke SetWindowPos,[hEdit],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOZORDER
	invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0

	invoke CreateFontIndirect,offset Courier_New_9
	mov [hFont],eax
	invoke SendMessage,[hEdit],WM_SETFONT,[hFont],FALSE

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, offset msg,NULL,0,0
		or rax,rax
		jz >>
			invoke IsDialogMessage, [hDlg], offset msg
			or rax,rax
			jnz <<
				invoke TranslateMessage, offset msg
				invoke DispatchMessage, offset msg
				jmp <<
	:

	mov rax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,esi,ebx
	LOCAL	rect			:RECT
	LOCAL	rect2			:RECT
	LOCAL	pText			:%PTR
	LOCAL	hFile			:%HANDLE
	LOCAL	cbWritten		:D

	.WM_SIZING
	cmp S[uMsg],WM_SIZING
	jne >>.WM_SIZE
		invoke GetClientRect,[hDlg],offset rect
		invoke GetWindowRect,[hToolbar],offset rect2
		mov eax,[rect2.bottom]
		sub eax,[rect2.top]
		add [rect.top],eax
		sub [rect.bottom],eax
		invoke SetWindowPos,[hEdit],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOZORDER
		invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0
		jmp >>.DEFPROC

	.WM_SIZE
	cmp S[uMsg],WM_SIZE
	jne >>.WM_NOTIFY
		invoke GetClientRect,[hDlg],offset rect
		invoke GetWindowRect,[hToolbar],offset rect2
		mov eax,[rect2.bottom]
		sub eax,[rect2.top]
		add [rect.top],eax
		sub [rect.bottom],eax
		invoke SetWindowPos,[hEdit],NULL,[rect.left],[rect.top],[rect.right],[rect.bottom],SWP_NOZORDER
		invoke SendMessage,[hToolbar],TB_AUTOSIZE,0,0
		jmp >>.DEFPROC

	.WM_NOTIFY
	cmp S[uMsg],WM_NOTIFY
	jne >>.WM_COMMAND
		mov edi,[lParam]
		.TBN_GETBUTTONINFO
		cmp D[edi+NMHDR.code], TTN_NEEDTEXT
		jne >>.DEFPROC
			mov eax,[hInstance]
			mov [edi+NMTTDISPINFO.hInst],eax
			mov eax,[edi+NMTTDISPINFO.hdr.idFrom]
			mov [edi+NMTTDISPINFO.lpszText],eax
			ret

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_DESTROY
		movzx edx,W[wParam]
		cmp edx,5000 ; Open
		jne >>
			invoke GetOpenFile,[hwnd]
			invoke CreateFile,OFFSET ofrFilePath,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
			mov [hFile],eax
			test eax,eax
			js >>.DEFPROC

			invoke SendMessage,[hEdit],WM_SETTEXT,0,0
			invoke GetFileSize,[hFile],offset cbWritten
			mov ebx,eax
			invoke GlobalAlloc,GMEM_FIXED,ebx
			mov [pText],eax

			invoke ReadFile,[hFile],[pText],ebx,offset cbWritten,NULL
			invoke SendMessage,[hEdit],WM_SETTEXT,0,[pText]
			invoke CloseHandle,[hFile]
			invoke GlobalFree,[pText]
			jmp >>.DEFPROC

		:
		cmp edx,5001 ; Save
		jne >>
			invoke SendMessage,[hEdit],WM_GETTEXTLENGTH,0,0
			test eax,eax
			jz >>.DEFPROC
			inc eax
			mov ebx,eax

			invoke GetSaveFile,[hwnd]
			invoke CreateFile,OFFSET ofrFilePath,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
			mov [hFile],eax
			test eax,eax
			js >>.DEFPROC

			invoke GlobalAlloc,GMEM_FIXED,ebx
			mov [pText],eax
			invoke SendMessage,[hEdit],WM_GETTEXT,ebx,[pText]

			invoke WriteFile,[hFile],[pText],ebx,offset cbWritten,NULL
			invoke CloseHandle,[hFile]
			invoke GlobalFree,[pText]
			jmp >>.DEFPROC

		:
		cmp edx,5002 ; Clear
		jne >
			invoke SendMessage,[hEdit],WM_SETTEXT,0,0
			jmp >>.DEFPROC

		:
		cmp edx,5003 ; Always on top
		jne >>.DEFPROC
			cmp D[fAlwaysOnTop],FALSE
			jne >
			mov D[fAlwaysOnTop],TRUE
			invoke SetWindowPos,[hwnd],HWND_TOPMOST,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE
			jmp >>.DEFPROC
			:
			mov D[fAlwaysOnTop],FALSE
			invoke SetWindowPos,[hwnd],HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE
			jmp >>.DEFPROC

	.WM_DESTROY
	cmp S[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor rax,rax
	ret

ENDF

GetOpenFile FRAME hDlg
	LOCAL ofn				:OPENFILENAME
	LOCAL ofrFileTitle[64]	:%CHAR

	invoke RtlZeroMemory,offset ofn,SIZEOF OPENFILENAME
	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	mov eax,[hInstance]
	mov [ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofrFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov [ofn.lpstrTitle],OFFSET szOpenCaption
	mov D[ofn.Flags],OFN_FILEMUSTEXIST + OFN_NONETWORKBUTTON + OFN_EXPLORER + OFN_HIDEREADONLY
	mov [ofn.lpstrDefExt],OFFSET szDefExt

	invoke GetOpenFileName,ADDR ofn
	ret
ENDF

GetSaveFile FRAME hDlg
	LOCAL ofn				:OPENFILENAME
	LOCAL ofrFileTitle[64]	:%CHAR

	invoke RtlZeroMemory,offset ofn,SIZEOF OPENFILENAME
	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	mov eax,[hInstance]
	mov [ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofrFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov [ofn.lpstrTitle],OFFSET szSaveCaption
	mov D[ofn.Flags],OFN_NONETWORKBUTTON + OFN_EXPLORER + OFN_HIDEREADONLY
	mov [ofn.lpstrDefExt],OFFSET szDefExt

	invoke GetSaveFileName,ADDR ofn
	ret
ENDF
